

//------------------------------------------------------------------------------
// Programmed by Christof Ermer
//------------------------------------------------------------------------------

//SYSINFO
#define DATUM		"22.09.2011"
#define FUNKTION	"AVR16_Com_LCD_L298_V1.0"
#define HARDWARE	"AVR16_Com_LCD_L298_V1-0"
#define UHRZEIT	"12:00"
#define AUTOR		"Christof Ermer"
#define BAUDRATE	"BAUD 9600 8N1"

#define IHAVENOBRAIN	"I have no brain."	
#define USEYOURS		"Use your own"

/*  HISTORY 
In Interupts...alle Vars deklarieren mit 
volatile uint32_t Tickscounter..
*/

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>

#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>

//ACHTUNG STELLT OBSOLETE Procedure in header wieder her
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>

#include "main.h"		//with Hardware assigns
#include "uart.h"
#include "stepmot.h"



uint16_t ADC_10Bit(uint8_t ucChan);
//int32_t Round(double fIn);


#ifdef TIMER_TICK_USED
void StartTickTimer(void);	//0.1 Seconds  interrupt
#endif


#ifdef UART_USE_ENABLED
void UART_TXRX_Check(void);
void ResetRxBuff(void);
void PrintCR(void);
void PrintStrCR(const char* pStr);
void Print_PStrCR(PGM_P pmStr);
void CheckOrder(char* pcStr);
void LongToNumStr(int32_t lVal);
void PrintLongCR(int32_t lVal);
void FloatToNumStr(double fVal);
#endif



//CONSTANT ARRAYs IN .TEXT = ROM ARREA   .DATA IST SRAM !! .BSS SRAM
//const char MCA_DELIMTERSTR[] PROGMEM = { ',',0 };

// GLOBALE VARIABLEN 
//MSG
const char MCA_DELIMITER[] PROGMEM	= ",";
const char MCA_ISTGLEICH[] PROGMEM	= "=";
//const char MCA_VALUE[] PROGMEM	= "Value";

//gu8SineVal[iNN] = round( 127.5 * sin(2*M_PI* iNN/256.0) + 1 );
// f(x)= Amplitude * sin ( 2* M_PI * NN/X_AUFLOESUNG ) + OFFSET
/*
//f(x) = a * sin (2*Pi*x - b) + o
a ist die Amplitude
b ist die Phasenverschiebung
o ist der "Offset"-Wert
fr x setzt du halt n/d ein. (n  N) 
d ist die Schrittanzahl pro Periode
*/
/*
ODER
iNN)= 0..255
F(x) = 128 + 127* sin( iNN/2562*M_PI* )
*/

#ifdef UART_USE_ENABLED 
static char* gpcRxPars;
static char gcaRxStr[RX_STRMAX + 1]; //+1 for the 0
static char gcaNumStr[NUMMAX + 1]; //+1 for the 0
static char gcaStr[STRMAX + 1]; //+1 for the 0
static COMMAND_TYPE gsCmd;
#endif

//static uint8_t gcaSegmentStr[SEGMENTSTRMAX + 1]; //+1 for the 0
uint32_t gu32_Ticks; //  T2 timeCounter, only NN_Counter for Keypressings
#ifdef USE_ERROR_FLAG 
uint8_t gbErrorFlag;
#endif



#ifdef TIMER_TICK_USED 
// ****************************************************************
//volatile  SIGNAL(TIMER2_OVF_vect) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
SIGNAL( TIMER2_OVF_vect ) //oder SIGNAL--INTERRUPT(SIG_OVERFLOW2) = mit SEI am Anfang
// *******************************************************************
{
sei();
//cli();/ 
gu32_Ticks++;
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
#endif

	

// *************************************
void StartTickTimer(void)	//0.1 Seconds  interrupt
//Normal MODE OC2 Disconnect Prescale 64
// *************************************
{
unsigned char sreg;
sreg = SREG; //loakaler Speicher
cli();
//TIMSK &=  (~(_BV(TOIE2)) & ~(_BV(OCIE2)));
TIMSK &= ~( TIMSK_TOIE2_FLAG | TIMSK_OCIE2_FLAG );
gu32_Ticks = 0;
OCR2 = 0;
TCNT2 = 0;  //Timer MAX = TOP Compare
//TIMER STARTS with Presscale Select = 64
TCCR2 = TCCR2_CLK_256;	// 0000 0100//Timer Counter CTRL -- NORMAL MODE=NO OCR2
//TCCR2 = TCCR2_CLK_0;	//
TIMSK |= TIMSK_TOIE2_FLAG; //_BV(TOIE2); // BESSER == OVERFLOW 
SREG = sreg;
sei();
};


#ifdef  USE_TOGGLE_FLAG
// ****************************************************************
void ToggleTEST_BIT(uint8_t ucCnt)
// ****************************************************************
{ // #include <util\delay.h>  muss da sein
uint8_t ucNN;
for(ucNN=0; ucNN < ucCnt; ucNN++)
	{
	SET_TESTBIT_MAC;
	_delay_us(1);
	CLR_TESTBIT_MAC;
	_delay_us(1);
	};
};
#endif



#ifdef UART_USE_ENABLED 
// *******************************************************************
void ResetRxBuff(void)
// *******************************************************************
{
gpcRxPars = gcaRxStr; // Set parse pointer back;
*gpcRxPars = 0;	//clear Rx
};
#endif

#ifdef UART_USE_ENABLED 
// *******************************************************************
void UART_TXRX_Check(void)
/*	
* Get received character from ringbuffer
* uart_getc() returns in the lower byte the received character and
* in the higher byte (bit_MSK) the last receive error
* UART_NO_DATA is returned when no data is available.
*/
// *******************************************************************
{
uint16_t uiRxUart;
uiRxUart = uart_getc();//!FETCH ALLWAYS BYTE FROM RX RINGBUFF INTERRUPT!
if( !(uiRxUart & UART_NO_DATA) )  //0x0100
	{
//   * new data available from UART
//  * check for Frame or Overrun error
#ifdef UART_ERRORMSG 
	if( uiRxUart & (UART_FRAME_ERROR | UART_OVERRUN_ERROR | UART_BUFFER_OVERFLOW) )
		{
		ResetRxBuff();
		uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );// !! Init UART interface
// Framing Error detected, i.e no stop bit detected
		Print_PStrCR(  PSTR("UartErr") );
		};
#endif
//NOW SELCT ACTION FROM ORDER
//Check CR
	if(gpcRxPars < (gcaRxStr + RX_STRMAX))	//ENDANSCHLAG ERREICHT ?
		{
		switch( (unsigned  char)uiRxUart  )
			{
			case 32: // SPACE weg
				{
				break;
				};	           				
			case 10: // LF weg
				{
				break;
				};	           				
			case 13: // order!! from Terminal
				{
				CheckOrder(gcaRxStr);//gcaRxStr = accumulated str
				ResetRxBuff();
				break;
				};	           				
			default: //Accumulate
				{
      // Accumulate String only to gcaRxStr with uiAAA Parser
				*gpcRxPars++ = (unsigned  char)(uiRxUart & 0x0FF);//Append rxByte
				*gpcRxPars = 0; //ZERO carry
				};
			};//switch
		}// if (pcRxPars < (gcaRxStr + RXSTRMAX))
	else  // To much data Rx, than clear simple all
		{
	 //overflow of RX clears all
		ResetRxBuff();	// Clear Rx Parspointer in Buff an terminate RxStr with 0
		};//if(gpcRxPars < (gcaRxStr + RXSTRMAX))
// ENDE DER RX EMPFANGSAUSWERTUNG
	};
};
#endif


#ifdef UART_USE_ENABLED   //MAKLEFILE ANPASSEN
// *******************************************************************
void PrintCR(void)
// *******************************************************************
{
uart_putc( ASC_CR );
};


// *******************************************************************
void PrintStrCR(const char* pStr)
// *******************************************************************
{
uart_puts(pStr);
PrintCR();
};


// *******************************************************************
void Print_PStrCR(PGM_P pmStr)
// *******************************************************************
{
uart_puts_p(pmStr);
PrintCR();
};

// **********************************************
void LongToNumStr(int32_t lVal)
// **********************************************
{
//sprintf(gcaNumStr,"%ld", lVal);  //Ulong = %ld
ltoa(lVal, gcaNumStr, 10 );
};

// *******************************************************************
void PrintLongCR(int32_t lVal)
// *******************************************************************
{
LongToNumStr(lVal); PrintStrCR(gcaNumStr);
};

// **********************************************
void FloatToNumStr(double fVal)
// *************
{
dtostrf(fVal, FLOAT_PRAEDIGITS_MAX, FLOAT_DIGITS_MAX, gcaNumStr ); //[-]d.ddd
};

// *******************************************************************
void PrintFloatCR(double fVal)
// *******************************************************************
{
FloatToNumStr(fVal); PrintStrCR(gcaNumStr);
};
#endif

/*
int32_t Round(double fIn)
// **********************************************
{
return (int32_t)floor(fIn + 0.5);
};
*/

#ifdef ADC_USED_ENABLED
//****************************************************************
uint16_t ADC_10Bit(uint8_t ucChan)
//****************************************************************
{
//unsigned int sreg;
//sreg = SREG;
//cli();
//Wegen mglichem zugriffffehler auf Port A
DDRA = DDRA & ~(1<<ucChan);   //port A Chanel Bit Input  
PORTA = PINA & ~(1<<ucChan); //Wegen Pullup
  // Activate ADC with Prescaler 16 --> 1Mhz/16 = 62.5kHz
ADCSRA = _BV(ADEN) | _BV(ADPS2) | _BV(ADPS1) |_BV(ADPS0);  
 // Select pin ADC0 using MUX
ADMUX = (ucChan & ADC_MUX_MASK);
    
    //Start conversion
ADCSRA |= _BV(ADSC);

//SREG = sreg;
    // wait until converstion completed
while (ADCSRA & _BV(ADSC) ) 
	{
	wdt_reset();
	};	   
return ADC;// get converted value
};
#endif


// *******************************************************************
void CheckOrder(char *pcStrOrder) //von gcaRxStr
// *******************************************************************
{ //INPUT ERWARTET INDER FOR "BEFEHL,WERT" BSP: "SFR,1000"
//uint16_t uiCnt =0;
char * pStrTok; // fr strtok_r
char * pucCh = &pcStrOrder[ strlen(pcStrOrder) ]; // Stelle POINTER auf \0 Ende  // kein unsigned char*

strcpy(gcaStr, pcStrOrder);
strcpy_P(gcaNumStr, MCA_DELIMITER); //HILFSWEISE gcaNumStr fr ","

if( (pStrTok = strtok_r( pcStrOrder, gcaNumStr  , &pucCh)) != NULL)//Trenne CMD, von ID, -"$$$1,CMD
	{	
	strcpy(gsCmd.ucaCmd, pStrTok);
	}
else
	{
	*gsCmd.ucaCmd = 0;
	};
gsCmd.ucaCmd[ COMAMNDSIZEMAX ] = 0; //Sicherheitsterminierung COMAMNDSIZEMAX=10


//strcpy(gcaStr, pcStrOrder);

gsCmd.fCmdVal_1 = gsCmd.fCmdVal_2 = 0;
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_1 = atof(pStrTok);// Und dann TO Float	
	};
	
if( (pStrTok = strtok_r( NULL,  gcaNumStr, &pucCh)) != NULL)
	{
	gsCmd.fCmdVal_2 = atof(pStrTok);// Und dann TO Float	
	};

//========================================================================================

if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("PING") )  )    //ping
	{	
	Print_PStrCR( PSTR("PONG") );	
	};

#ifdef ADC_USED_ENABLED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("ADC"))  )    //ADC,0..7
	{	
	uart_puts_p(  PSTR("ADC") );
	uart_puts_p( MCA_ISTGLEICH );	
	PrintLongCR( ADC_10Bit( gsCmd.fCmdVal_1 ) );
	};
#endif



#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MO"))  ) 
	{
	gu8StepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG; //Kein Pulscount
	if((uint8_t)gsCmd.fCmdVal_1)	//OPTIONAL; GLEICH MIT pULScountangabe
		{
		gsStMPar.fSM_Soll_FRQ = gsCmd.fCmdVal_1;		
		};	
	StepMotorOn();
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MOPD"))  ) //MOTOr ON Pulse, Direction
	{
	SM_Run_Puls_DIR( (uint32_t)gsCmd.fCmdVal_1, (uint8_t)gsCmd.fCmdVal_2 );	//Default ist 200...
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MF"))  )
	{
	StepMotorOff();
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("MS"))  )
	{
	StepMotorStop();
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd,PSTR("SFR")) )    //TESTS
   {
	gsStMPar.fSM_Soll_FRQ = gsCmd.fCmdVal_1;
	Set_SM_FRQ(gsStMPar.fSM_Soll_FRQ);
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd,PSTR("DIR") ) )    //TESTS
   {
	if((uint8_t)gsCmd.fCmdVal_1)
		{
		SetMotorDirection( SM_DIR_LINKS );
		}
	else
		{
		SetMotorDirection( SM_DIR_RECHTS );
		};
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("RAMPE")) )
   {
	if( (uint8_t)gsCmd.fCmdVal_1 )
		{
		gsStMPar.u8SM_RampenSteigung = ((uint8_t)gsCmd.fCmdVal_1);
		gu8StepMConditionFlag |= STEPM_RAMPE_FLAG;		//Setze bits
		}
	else
		{
		gu8StepMConditionFlag &= ~STEPM_RAMPE_FLAG;		//Setze bits
		};
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd,PSTR("HALF") ) )
	{	
	Set_StepMotor_Mode( MODE_HALFSTEP );
	};
#endif
	
#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("FULL")) )
	{
	Set_StepMotor_Mode(  MODE_FULLSTEP );	
	};
#endif

#ifdef STEPMOTOR_USED
if( !strcasecmp_P( gsCmd.ucaCmd, PSTR("SPR"))  ) //Set Steps per Rotation
	{	//Default ist 200...
	gsStMPar.u16SM_StepsRotationType = (uint16_t)gsCmd.fCmdVal_1; //Normal 200
	};
#endif

if( !strcasecmp_P( gsCmd.ucaCmd,  PSTR("TT") ) )
	{
	PrintLongCR( gu32_Ticks );
	};
	
 };


// *******************************************************************
int main(void)
// *******************************************************************
{
//uint8_t u8NN;
//INITS
cli();//The global interrupt flag is maintained in the I bit of the status register (SREG).  
//Wichtige Schritte.. so bald wie mglich

//INIT HARDWARE
//USing of PORTOUTS  1=OUT, 0=IN
DDRA = PORTA_DDRX_OUT_MSK;
PORTA = PORTA_PRESET_PULL_MSK;
DDRB = PORTB_DDRX_OUT_MSK;
PORTB = PORTB_PRESET_PULL_MSK;
DDRC = PORTC_DDRX_OUT_MSK;
PORTC = PORTC_PRESET_PULL_MSK;
DDRD = PORTD_DDRX_OUT_MSK;
PORTD = PORTD_PRESET_PULL_MSK;

SM_INIT_DIRREG();
SM_InitStructVals();

//SFIOR = (1<<PUD); //Pullup Disable
StartTickTimer();	//8 Bit Timer 2 = MS Tick Counter
//Pointer and Strings init
wdt_enable(WDTO_2S); //Set 1.9Sec WatchDog ENABLE
wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

// Initialize UART library, pass baudrate and avr cpu clock
// with the macro UART_BAUD_SELECT()
ResetRxBuff();
uart_init( UART_BAUD_SELECT(UART_BAUD_RATE, F_CPU) );

Print_PStrCR( PSTR(HARDWARE) );
Print_PStrCR( PSTR(AUTOR) );
Print_PStrCR( PSTR(FUNKTION) );
Print_PStrCR( PSTR(DATUM) );
Print_PStrCR( PSTR(BAUDRATE) );
Print_PStrCR( PSTR(IHAVENOBRAIN) );
Print_PStrCR( PSTR(USEYOURS) );

gu32_Ticks = 0;
// ************ MAIN LOOP *********************
for (;;)  /* loop forever */ //Aber schnell > 200.000 mal/Sekunde
// ************ MAIN LOOP *********************
	{	
	sei();
 	wdt_reset();	//WATCHDOG!
//SekundenTick
	if( !(gu32_Ticks % 244 ) ) //Hier kann was gemacht werden jede 1/10 Sekunde
		{
		PrintLongCR( gu32_Ticks);		
		};


	}; //main loop Ende
#ifdef UART_USE_ENABLED
UART_TXRX_Check();	//IMMER VORNAHANDEN !! IN ALLEN LOOPS DIE ZEIT BRAUCHEN
#endif
};
// ******************* MAIN END ********************************************


