

#include <avr\io.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr\pgmspace.h> // <--#include <progmem.h>
#include <string.h>
#include <avr\interrupt.h>  // obsolete #include <avr\signal.h>
#include <util\delay.h>	//_delay_loop_1 _delay_loop_2 delay_ms
#include <avr\wdt.h>
#include <math.h>


#include "stepmot.h"


//FULLSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0011 1001 = 0x39
//0011 0101 = 0x35
//0011 0110 = 0x36
//const uint8_t MCA_FULLSTEPS[] PROGMEM = {0xBA,0xB9,0xB5,0xB6};	//CONST ARRAY
const char MCA_FULLSTEPS[] PROGMEM = {0x3A,0x39,0x35,0x36};	//CONST ARRAY
//HALFSTEP ENABLE_B ENABLE_A BITS 3..0
//0011 1010 = 0x3A
//0010 1000 = 0x28
//0011 1001 = 0x39
//0001 0001 = 0x11
//0011 0101 = 0x35
//0010 0100 = 0x24
//0011 0110 = 0x36
//0001 0010 = 0x12
const char MCA_HALFSTEPS[] PROGMEM = {0x3A,0x28,0x39,0x11,0x35,0x24,0x36,0x12};	//CONST ARRAY

//Sonstige Globals

STEPMPARTYPE gsStMPar;	//SPEICHERT DIE PARAMETER //definition in Main.H
uint8_t gu8StepPars; //+1 or -1 for the Bitpatternselect

uint8_t gucModePatternModulo; // Modulo selector (HALF/FULLSTEP..)
static PGM_P gpmpaStepPattern;
static uint8_t gu8Timer_CSxxClkSelect;
static float gfSMRealFrq;
uint8_t gu8StepMConditionFlag;	//ISTZUSTAND wir Mode
uint8_t gu8SM_PostionFlag;


//************************	****************************************
ISR(TIMER0_OVF_vect) //TIMER0_OVF_vect
//*******************************************************************
{
sei();
SM_PORT_OUT |= SM_ENABLE_MSK;	 // ehalte alle anderen Bits
//| 		(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gu8StepPars % gucModePatternModulo) ) ) ); 			 
};


//************************	****************************************
ISR(TIMER0_COMP_vect)
//*******************************************************************
{
sei();
SM_PORT_OUT &= ~SM_ENABLE_MSK;	// ehalte alle anderen Bits	
}; 


// ***** ***********************************************************
ISR( TIMER1_COMPA_vect )// signal handler	/#define SIG_OUTPUT_COMPARE1A	_VECTOR(6)
// *******************************************************************
{
//static uint8_t ucBitpattern;
//I_SREG automtaic clear by Interrupt and Enabled by RETI	
sei();	//INTERRUPT ENABLE
if( gu8StepMConditionFlag & STEPM_RUN_FLAG )
	{
#if SM_LINE_FUCNTIONS_ENABLED == 1
	//Long DISTAcNE with multiple roations --> ein Target in einer Bewegungsachse +/- um den Indexpunkt
	if( (gu8SM_PostionFlag & POSITION_STOP_ON_DISTANCE_MODE_FLAG) &&
		(gliLIneTargePoint == gsStMPar.iSM_IndexDifference  )
	)
		{
		StepMotorStop();
		//gu8SM_PostionFlag &= ~POSITION_STOP_ON_DISTANCE_MODE_FLAG;
		return;		
		};
#endif

#if SM_SECTOR_FUNCTIONS_ENABLED == 1	
	//Target ->meint Target in einer Rotation
	if( (gu8SM_PostionFlag & POSITION_STOP_ON_TARGET_MODE_FLAG) &&
		( guiMTargetPoint == gsStMPar.iSM_RotPosition )
	)
		{
		StepMotorStop();
		//gu8SM_PostionFlag &= ~POSITION_STOP_ON_TARGET_MODE_FLAG;
		return;		
		};
#endif	
	//check MOP Count...
	if(	(gu8StepMConditionFlag & STEPM_PULSE_MODE_FLAG) && 
			(gsStMPar.u32MovedSteps >= gsStMPar.u32SM_ToRunCnt )
	)
		{		
		StepMotorStop();	//EVTL. MIT AUTORELEASE_TIMEOUT
		//gu8StepMConditionFlag &= ~STEPM_PULSE_MODE_FLAG;
		return;
		//StepMotorOff();//GEHT NICHT; WEIL ER SONST ZU SCHNELL AUSSCHALTET
		};	

	//Zuerst  Bitmuster whlen, damit Motor immer auf gu8StepPars steht.
	if( gu8StepMConditionFlag & STEPM_DIRECTION_FLAG )		
		{//Linksrum Relativ zu Markerpfeil am Rand....
		gu8StepPars--;
		}
	else
		{//Rechts
		gu8StepPars++;
		};	
	//gu8StepPars = ZahlenRing(gu8StepPars, gucModePatternModulo);
	//gu8StepPars %= ZahlenRing(gu8StepPars, gucModePatternModulo);
//PrintFloatCRLF(gu8StepPars);	
	//Bitmuster am Schrittmotor ausgeben
	SM_PORT_OUT = ((SM_PORT_OUT) & (~SM_ALLCTRL_MSK))	| //ODER . ehalte alle anderen Bits	
		(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gu8StepPars % gucModePatternModulo) ) ) ); 			 
	gsStMPar.u32MovedSteps++; //Zhle die Pulse.. !!				

//RAMPE Nachstellen
	if( (gu8StepMConditionFlag & STEPM_RAMPE_FLAG ) && //RAMPEnFAHREN Situation
		(gu8StepMConditionFlag & STEPM_START_RAMPE_FLAG)
	)//Frequenz nur setzen, wenn Rampe aktiv
		{
		gsStMPar.fSM_Ist_Frq += (float)gsStMPar.u8SM_RampenSteigung; // Rampe hochfahren		
		if( gsStMPar.fSM_Ist_Frq > gsStMPar.fSM_Soll_FRQ )
			{			
			gsStMPar.fSM_Ist_Frq = gsStMPar.fSM_Soll_FRQ;
			gu8StepMConditionFlag &= ~STEPM_START_RAMPE_FLAG;	//RAMPE EREICHT					
			};
		Set_SM_FRQ( gsStMPar.fSM_Ist_Frq );
		};	
	//---------------------
	}
else	//gu8StepMConditionFlag & STEPM_ENABLE_FLAG
	{
	StepMotorStop();
	};	
};



//Haltestrom mit PWM
// *************************************
void Timer0_PWM( uint8_t u8PwmRange) // 0..255 PWM 0  bis maximal 
// *************************************
{  // 8BIT TIMER T0
unsigned char sreg;
sei();
sreg = SREG; //loakaler Speicher
TIMSK &= ~( _BV(TOIE0) | _BV(OCIE0)  );
TCNT0=  0;    //Timer MAX = TOP Compare
OCR0 = u8PwmRange;
TCCR0 =  TCCR0_CLK_0;
TIMSK |= (_BV(TOIE0) | _BV(OCIE0));
SREG = sreg;
};



// *************************************
void Timer0_PWM_STOP(void)
// *************************************
{
unsigned char sreg;
sei();
sreg = SREG; //loakaler Speicher
TIMSK &= ~( _BV(TOIE0) | _BV(OCIE0)  );
TCCR0 &= TCCR0_CLK_STOP_MASK;
SREG = sreg;
SM_PORT_OUT = ((SM_PORT_OUT) & (~SM_ALLCTRL_MSK))	| //ODER . ehalte alle anderen Bits	
		(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + (gu8StepPars % gucModePatternModulo) ) ) ); 			 
};


// *************************************
void Set_StepMotor_Mode(uint8_t ucVal) 
//gu8StepMConditionFlag & STEPM_STEPMODE12_MASK
// *************************************
{ //0 = FULL_STEP 1= HALFSTEP;
//Berechne tatschliche Schritte pro Rotation
gsStMPar.u8SM_Mode = ucVal;
gsStMPar.u16StepsPerRotation = gsStMPar.u16SM_StepsRotationType * ucVal;//wegen:half/full
switch(ucVal)
	{
	case MODE_FULLSTEP :	//*1
		{//FULL 1
		//gsStMPar.u8SM_Mode = MODE_FULLSTEP;
		gpmpaStepPattern 	= MCA_FULLSTEPS;	//MCA pointer Adr.
		gucModePatternModulo = FULLSTEPMODEPARSMAX;//4
		break;
		};
	case MODE_HALFSTEP :	//*2
		{
		//gsStMPar.u8SM_Mode = MODE_HALFSTEP;
		gpmpaStepPattern = MCA_HALFSTEPS;	//MCA pointer Adr.
		gucModePatternModulo = HALFSTEPMODEPARSMAX;//8 
		break;
		};
	};
};


// *************************************
void SetMotorDirection(uint8_t ucVal)
// *************************************
{//0= Rechts  1=Linksrum
//Nur wenn nicht schon so eingestellt
//Geht nur, weil #define STEPM_DIRECTION_FLAG		0x01= NULL Bit --> Sonst Shift Bit
if( (gu8StepMConditionFlag & STEPM_DIRECTION_FLAG) ^ ucVal )  //EXOR ungleich?
	{
	if(ucVal) //1 == links
		{
		gu8StepMConditionFlag |= STEPM_DIRECTION_FLAG;
		}
	else//dir == 0 == rechts
		{
		gu8StepMConditionFlag &= ~STEPM_DIRECTION_FLAG;
		};
//Falls Motor grad aktiv ist,,halt in an,und ndere die Richtung		
	if( (gu8StepMConditionFlag & STEPM_ENABLE_FLAG)  && 
		(gu8StepMConditionFlag & STEPM_RUN_FLAG ) 
	)
		{
		StepMotorStop();
		gu8StepMConditionFlag |= STEPM_START_RAMPE_FLAG;		
		StepMotorOn();
		};
	};
};




// *************************************
void StepMotorOn(void)
// *************************************
{
	//Verriegelung, falls der Motor an den Anschlagschalterns steht, 
	//das er in die falsche Richtung anstartet	
	//0x10 Wert des EXtswitch via INT1 = LINKS
	//define MODE_FULLSTEP 0x00	define MODE_HALFSTEP 0x01
	//1. Warte auf Stop --> Ist der Auftrag erledigt, (verhindert widersprechnede Befehle)
/*
	while( !(gu8SM_PostionFlag & POSITION_STOP_ON_TARGET_OK) )	
		{//Damit der Motor sich beruhigen kann
		wdt_reset();   //WATCHDOG!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		};
*/
#ifdef USE_ENDPOSITION_SWITCH_INT0
if( !(gstInt0Key.ucKeyStat & KEYSTAT_RELEASED) && 
	(
	(
	(gstInt0Key.ucKey == KEY_ENDSWITCH_LEFT ) && (gu8StepMConditionFlag & STEPM_DIRECTION_FLAG)
	) || 
	(
	( gstInt0Key.ucKey == KEY_ENDSWITCH_RIGHT )  &&  !(gu8StepMConditionFlag & STEPM_DIRECTION_FLAG)
	)
	)
  )
	{
	return;
	};
#endif
		
	Timer0_PWM_STOP();
	Set_StepMotor_Mode( gsStMPar.u8SM_Mode );		
	
	//Nur Rampe wenn FRQ > PREDEF_RAMPENSSTARTFRQ
	if( (gsStMPar.fSM_Soll_FRQ > PREDEF_RAMPENSSTARTFRQ) && //> 10.0, also mit RAMPE
		(gu8StepMConditionFlag & STEPM_RAMPE_FLAG) 
	)
		{
		gu8StepMConditionFlag |= STEPM_START_RAMPE_FLAG;  //START !!!! Situation
		gsStMPar.fSM_Ist_Frq = PREDEF_RAMPENSSTARTFRQ;
		}
	else//KEINE RAMPE
		{ 
		gsStMPar.fSM_Ist_Frq = gsStMPar.fSM_Soll_FRQ;	//Set Frequenz wie in Struct.
		};	
	
	gsStMPar.u32MovedSteps = 0;	//COUNTSZHLER !!!!!!!
	
	//Lege die letzen Bitts an...
	if( !(gu8StepMConditionFlag & STEPM_ENABLE_FLAG) )
		{		
		SM_PORT_OUT = ((SM_PORT_OUT ) & ~SM_ALLCTRL_MSK)	| //ODER . clear SMbit und erhalte alle anderen Bits	
			(pgm_read_byte_near( (PGM_P)(gpmpaStepPattern + gu8StepPars) ) );		
		//Unbedingt warten damit Magnetfeld sich aufbauen und fangen kann.
		wdt_reset();
		_delay_ms( Motor_START_LAST_BITPATTERN_ON_TIME );	//30ms	
		};	
	//3.erst dann Starte	
	gu8StepMConditionFlag |= STEPM_ENABLE_FLAG | STEPM_RUN_FLAG;//ENABLE ANZEIGEN (INTERRUPPT)UND SPEICHERN		
	gu8StepMConditionFlag &= ~(STEPM_STOP_ACTIVE_FLAG | STEPM_TIMEOUT_ENABLE_FLAG);	//Lsche Pausebedingung	
	gu8SM_PostionFlag &= ~POSITION_STOP_ON_TARGET_OK;
	Set_SM_FRQ(gsStMPar.fSM_Ist_Frq);
	StepFRQ_OnOff(FRQ_ON); 
};



// *************************************
void StepMotorStop(void)	//hlt mOTOR an, ictrl/pwm,bleibt ENABLE !!
// *************************************
{
StepFRQ_OnOff(FRQ_OFF);	//0
//ENABELD ( STROM AKTIV !!!!)
//Jetzt mit allen Flags aufrumen
gu8StepMConditionFlag &= ~(STEPM_RUN_FLAG | STEPM_PULSE_MODE_FLAG);
gu8SM_PostionFlag &= ~(POSITION_STOP_ON_DISTANCE_MODE_FLAG | POSITION_STOP_ON_TARGET_MODE_FLAG);
gu8SM_PostionFlag |= POSITION_STOP_ON_TARGET_OK;
//MIT BEIDE ENABLES ON
SM_PORT_OUT |= SM_ENABLE_MSK;
Timer0_PWM( gsStMPar.u8Stop_PWM_Rate ) ;
gu8StepMConditionFlag |= STEPM_STOP_ACTIVE_FLAG | STEPM_TIMEOUT_ENABLE_FLAG;	//Zeige Stopstatus-ENABLED an
};


// *************************************
void StepMotorOff(void)	//Komplett STOPS AND FREE axis.
// *************************************
{
StepMotorStop();
Timer0_PWM_STOP();
SM_PORT_OUT &= ~SM_ENABLE_MSK; // Lsche nur!  Enable Status
//Lsche Stopstatus
gu8StepMConditionFlag &= ~(STEPM_ENABLE_FLAG | STEPM_STOP_ACTIVE_FLAG | STEPM_RUN_FLAG); 
//NUR CONTROLL LIENES; ENABLE ARE ACTIV. //BITS LASSEN; WIE SIE SIND..!!!!
};



// *************************************
void Set_SM_FRQ(float fVal)
// *************************************
{
float fComVal;
float fTimerDivider;

//if( fVal > MAXIMAL_FRQ ) return;
if( fVal < MINIMAL_FRQ ) return;
//Voreinstellung
fTimerDivider = TIMER_DIVIDE_FRQ_1; //if( fVal < TIMER_HALFCOMP_FRQ_1024)	
gu8Timer_CSxxClkSelect = TCCR1B_CLOCKSEL_CPU_1;
//Clock udn OCR1A so hoch als mglich
if( ( fComVal = F_CPU / fVal )  > 0xFFFF ) 
	{ 
	fTimerDivider = TIMER_DIVIDE_FRQ_8; //if( fVal < TIMER_HALFCOMP_FRQ_1024)	
	gu8Timer_CSxxClkSelect = TCCR1B_CLOCKSEL_CPU_8;
	if( ( fComVal = TIMER_DIVIDE_FRQ_8 / fVal )  > 0xFFFF ) 
		{ 
		fTimerDivider = TIMER_DIVIDE_FRQ_64; //if( fVal < TIMER_HALFCOMP_FRQ_1024)	
		gu8Timer_CSxxClkSelect = TCCR1B_CLOCKSEL_CPU_64;
		if( ( fComVal = TIMER_DIVIDE_FRQ_64 / fVal )  > 0xFFFF )
			{
			fTimerDivider = TIMER_DIVIDE_FRQ_256; //if( fVal < TIMER_HALFCOMP_FRQ_1024)	
			gu8Timer_CSxxClkSelect = TCCR1B_CLOCKSEL_CPU_256;
			if( ( fComVal = TIMER_DIVIDE_FRQ_256 / fVal )  > 0xFFFF )
				{	
				fTimerDivider = TIMER_DIVIDE_FRQ_1024; //if( fVal < TIMER_HALFCOMP_FRQ_1024)	
				gu8Timer_CSxxClkSelect = TCCR1B_CLOCKSEL_CPU_1024;
				fComVal = TIMER_DIVIDE_FRQ_1024 / fVal;
				}}}};
cli();
TCNT1 = 0;  //sicherung gegenen unbeabsichtigten Overrrun
OCR1A = (uint16_t)round( fComVal );
if(OCR1A)
	{
	gfSMRealFrq = fTimerDivider / OCR1A;
	};
//Vorteiler setzen
TCCR1B = TCCR1B_CTC_MODE | gu8Timer_CSxxClkSelect;	//mode 4 Clear Timer on Compare=CTC.  MODE 4 an OCR1A + / CLk/1024
sei();
};



// *************************************
void StepFRQ_OnOff(uint8_t uOnOff)
// *************************************
{
cli();
TCCR1B = TCCR1B_CLOCKSEL_STOP;	//Stopen, damit keine geschachtelten Interrrupts passieren...
if( uOnOff )  // Im FALLE DAS FRQ = 0 MOTOR STOP !
	{
	TCCR1B = TCCR1B_CTC_MODE | gu8Timer_CSxxClkSelect;//Clear Timer on Compare=CTC.  MODE an OCR1A + / CLk/1024
	TCNT1 = 0;/* reset TCNT1 */
	TIMSK |= _BV(OCIE1A );	//Interrupt ein
//1.Write High	
//	timer_enable_int(_BV(OCIE1A));	//WARNUNG TIMSK wird BERSCHRIeBEN
	}
else
	{
	TIMSK &= ~_BV(OCIE1A );  //Interrupt OFF
	TCCR1B &=  TCCR1B_CLOCKSEL_MSK;
	};
sei();
};



// *******************************************************************
void SM_Run_Puls_DIR(uint32_t uiPuls, uint8_t ucDir)
// *******************************************************************
{
SetMotorDirection( ucDir );
gsStMPar.u32SM_ToRunCnt = uiPuls;
gu8StepMConditionFlag |= STEPM_PULSE_MODE_FLAG;
StepMotorOn();
};



//Init
// *******************************************************************
void SM_InitStructVals(void)
// *******************************************************************
{
gsStMPar.fSM_Soll_FRQ = PREDEF_STEPFREQUENZ;		//Default 100.0
gsStMPar.u8SM_Mode = PREDDEF_STEPMODE;				//MODE_HALFSTEP
gsStMPar.fSM_Ist_Frq = PREDEF_RAMPENSSTARTFRQ; 	//10.0 
gsStMPar.u8SM_RampenSteigung = PREDEF_RAMP_RISE;	//Default 0
gsStMPar.u32SM_ToRunCnt = PREDEF_STEPRCLOCKS;//= 1 wieviele Steps soll der Motor gehen(Default= 1)
gsStMPar.u16SM_StepsRotationType = PREFDEF_STEPS_PER_ROTATION;	//Default 400
gsStMPar.u8Stop_PWM_Rate = PREDEF_STOP_PWM_RATE;
};

